题目链接:http://poj.org/problem?id=3126
Prime Path
Time Limit: 1000MS | Memory Limit: 65536K | |
Total Submissions: 32036 | Accepted: 17373 |
Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
1733
3733
3739
3779
8779
8179
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3 1033 8179 1373 8017 1033 1033
Sample Output
6 7 0
求出素数在对每个位上的数进行bfs即可
#include<iostream> #include<queue> using namespace std; int n,x,y,prime[10005],visit[10005],v[10005],ans; void Prime()//欧拉筛 { for(int i=2;i<=10000;i++) { if(!visit[i]) { prime[++prime[0]]=i; } for(int j=1;j<=prime[0]&&i*prime[j]<=10000;j++) { visit[i*prime[j]]=1; if(i%prime[j]==0)break; } } } struct node{ int a[4],num,cnt; }; int change(node p) { return p.a[0]*1000+p.a[1]*100+p.a[2]*10+p.a[3]; } queue<node>q; int bfs(node p) { while(!q.empty()) q.pop(); q.push(p); p.num=change(p); v[p.num]=1; while(!q.empty()) { p=q.front(); if(p.num==y)return p.cnt; q.pop(); for(int i=0;i<4;i++) { for(int j=0;j<10;j++) { if(i==0&&j==0)continue; node w=p; w.a[i]=j; w.num=change(w); if(!visit[w.num]&&!v[w.num]) { w.cnt++; q.push(w); v[w.num]=1; } } } } return -1; } int main() { Prime(); cin>>n; while(n--) { cin>>x>>y; for(int i=1000;i<=10000;i++) v[i]=0; node p; int num=x; for(int i=3;i>=0;i--) { p.a[i]=num%10; num/=10; } p.num=change(p); p.cnt=0; ans=bfs(p); if(ans!=-1)cout<<ans<<endl; else cout<<"Impossible"<<endl; } return 0; }